Attribute VB_Name = "BucketHashing"
' ************************************************
' Bucket2.BAS
'
' Source code for hashing with buckets on disk
' example program.
' ************************************************
' Copyright (C) 1995 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Global Const HASH_FOUND = 0
Global Const HASH_NOT_FOUND = 1
Global Const HASH_INSERTED = 2

Global Const ITEMS_PER_BUCKET = 10  ' Items per bucket.
Global Const MAX_ITEM = 9           ' ITEMS_PER_BUCKET - 1.

Type ItemType
    Value As Long
End Type
Global Const ITEM_SIZE = 4      ' Size of this type.

Type BucketType
    Item(0 To MAX_ITEM) As ItemType
End Type
Global Const BUCKET_SIZE = ITEMS_PER_BUCKET * ITEM_SIZE

' This value indicates an unused entry.
Global Const UNUSED = -2147483648#

