VERSION 4.00
Begin VB.Form ChainForm 
   Caption         =   "Chain"
   ClientHeight    =   4605
   ClientLeft      =   1470
   ClientTop       =   1125
   ClientWidth     =   6030
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   5295
   Icon            =   "Chain.frx":0000
   Left            =   1410
   LinkTopic       =   "Form1"
   ScaleHeight     =   4605
   ScaleWidth      =   6030
   Top             =   495
   Width           =   6150
   Begin VB.Frame Frame2 
      Caption         =   "Search"
      Height          =   1095
      Left            =   0
      TabIndex        =   10
      Top             =   3000
      Width           =   2055
      Begin VB.TextBox NewItem 
         Height          =   285
         Left            =   1080
         TabIndex        =   6
         Top             =   240
         Width           =   615
      End
      Begin VB.CommandButton CmdAdd 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         Caption         =   "Add"
         Enabled         =   0   'False
         Height          =   375
         Left            =   360
         TabIndex        =   7
         Top             =   600
         Width           =   615
      End
      Begin VB.CommandButton CmdFind 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         Caption         =   "Find"
         Enabled         =   0   'False
         Height          =   375
         Left            =   1080
         TabIndex        =   8
         Top             =   600
         Width           =   615
      End
      Begin VB.Label Label1 
         Caption         =   "Value"
         Height          =   255
         Index           =   0
         Left            =   360
         TabIndex        =   11
         Top             =   240
         Width           =   615
      End
   End
   Begin VB.Frame Frame3 
      Caption         =   "Random Items"
      Height          =   1455
      Left            =   0
      TabIndex        =   16
      Top             =   1560
      Width           =   2055
      Begin VB.TextBox NumItemsText 
         Height          =   285
         Left            =   1080
         TabIndex        =   3
         Text            =   "30"
         Top             =   240
         Width           =   615
      End
      Begin VB.TextBox MaxValueText 
         Height          =   285
         Left            =   1080
         TabIndex        =   4
         Text            =   "999"
         Top             =   600
         Width           =   615
      End
      Begin VB.CommandButton CmdAddRandom 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         Caption         =   "Create Items"
         Enabled         =   0   'False
         Height          =   375
         Left            =   360
         TabIndex        =   5
         Top             =   960
         Width           =   1335
      End
      Begin VB.Label Label1 
         Caption         =   "# Items"
         Height          =   255
         Index           =   6
         Left            =   360
         TabIndex        =   14
         Top             =   240
         Width           =   735
      End
      Begin VB.Label Label1 
         Caption         =   "Max"
         Height          =   255
         Index           =   2
         Left            =   360
         TabIndex        =   17
         Top             =   600
         Width           =   615
      End
   End
   Begin VB.TextBox TableText 
      BackColor       =   &H8000000F&
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3975
      Left            =   2160
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   9
      Top             =   120
      Width           =   3855
   End
   Begin VB.Frame Frame1 
      Caption         =   "Table Creation"
      Height          =   1455
      Left            =   0
      TabIndex        =   12
      Top             =   0
      Width           =   2055
      Begin VB.CheckBox SortListsCheck 
         Caption         =   "Sort Lists"
         Height          =   255
         Left            =   360
         TabIndex        =   1
         Top             =   600
         Width           =   1335
      End
      Begin VB.CommandButton CmdNewTable 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         Caption         =   "Create Table"
         Height          =   375
         Left            =   360
         TabIndex        =   2
         Top             =   960
         Width           =   1335
      End
      Begin VB.TextBox TableSize 
         Height          =   285
         Left            =   1080
         TabIndex        =   0
         Text            =   "10"
         Top             =   240
         Width           =   615
      End
      Begin VB.Label Label1 
         Caption         =   "# Lists"
         Height          =   255
         Index           =   3
         Left            =   360
         TabIndex        =   13
         Top             =   240
         Width           =   735
      End
   End
   Begin VB.Label StatusLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   495
      Left            =   0
      TabIndex        =   15
      Top             =   4110
      Width           =   6015
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "ChainForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Chain.FRM
'
' Main form for hashing with chaining example
' program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Dim MaxValue As Long

' Create a hash table.
Dim HashTable As New ChainingHashTable
' ************************************************
' Add an item to the hash table.
' ************************************************
Private Sub CmdAdd_Click()
Dim Value As Long
Dim probes As Integer
Dim status As Integer

    MousePointer = vbHourglass
    DoEvents

    If Not IsNumeric(NewItem.Text) Then NewItem.Text = "1"
    Value = CLng(NewItem.Text)
    If Value > MaxValue Then MaxValue = Value
    
    ' Insert the item.
    status = HashTable.InsertItem(Value, probes)
    Select Case status
        Case HASH_FOUND
            DisplayStatus "Found.", probes
        Case HASH_INSERTED
            DisplayStatus "Inserted.", probes
    End Select

    HashTable.DisplayTable Value, TableText
    MousePointer = vbDefault
End Sub

' ************************************************
' Add random items to the hash table.
' ************************************************
Private Sub CmdAddRandom_Click()
Dim num As Integer
Dim done As Integer
Dim probes As Integer
Dim status As Integer
Dim Value As Long
Dim max_value As Long

    max_value = CLng(MaxValueText.Text)
    num = CInt(NumItemsText.Text)
    If max_value < num Then
        Beep
        MsgBox "Max Value is too small."
        Exit Sub
    End If

    MousePointer = vbHourglass
    DoEvents

    done = 0
    Do While done < num
        Value = Int(max_value * Rnd) + 1
        If Value > MaxValue Then MaxValue = Value
        If HashTable.InsertItem(Value, probes) = _
            HASH_INSERTED Then done = done + 1
    Loop
    DisplayStatus "Done.", probes
    
    HashTable.DisplayTable -1, TableText
    MousePointer = vbDefault
End Sub

' ************************************************
' Find a value in the hash table.
' ************************************************
Private Sub CmdFind_Click()
Dim Value As Long
Dim probes As Integer
Dim status As Integer

    MousePointer = vbHourglass
    DoEvents

    If Not IsNumeric(NewItem.Text) Then NewItem.Text = "1"
    Value = CLng(NewItem.Text)
    If Value > MaxValue Then MaxValue = Value
    
    status = HashTable.LocateItem(Value, probes)
    Select Case status
        Case HASH_NOT_FOUND
            DisplayStatus "Not found.", probes
        Case HASH_FOUND
            DisplayStatus "Found.", probes
    End Select

    HashTable.DisplayTable Value, TableText
    MousePointer = vbDefault
End Sub

' ************************************************
' Create and initialize a new table.
' ************************************************
Private Sub CmdNewTable_Click()
    MousePointer = vbHourglass
    DoEvents

    If Not IsNumeric(TableSize.Text) Then TableSize.Text = "10"
    
    ' This makes the HashTable create the lists.
    HashTable.NumLists = CInt(TableSize.Text)
    HashTable.SortLists = (SortListsCheck.Value = 1)

    MaxValue = 1

    TableSize.Text = ""
    StatusLabel.Caption = "Table created."
    CmdAddRandom.Enabled = True
    HashTable.DisplayTable -1, TableText
    MousePointer = vbDefault
End Sub

' ************************************************
' Compute the average number of items necessary
' for all possible inputs.
' ************************************************
Private Sub ComputeAverageProbe(ave_succ As Single, ave_unsucc As Single)
Dim status As Integer
Dim trial As Long
Dim succ As Long
Dim succ_probes As Long
Dim unsucc As Long
Dim unsucc_probes As Long
Dim probes As Integer

    For trial = 1 To MaxValue
        status = HashTable.LocateItem(trial, probes)
        If status = HASH_FOUND Then
            succ = succ + 1
            succ_probes = succ_probes + probes
        Else
            unsucc = unsucc + 1
            unsucc_probes = unsucc_probes + probes
        End If
    Next trial
    
    If succ > 0 Then
        ave_succ = CDbl(succ_probes) / CDbl(succ)
    Else
        ave_succ = 0
    End If
    
    If unsucc > 0 Then
        ave_unsucc = CDbl(unsucc_probes) / CDbl(unsucc)
    Else
        ave_unsucc = 0
    End If
End Sub

' ************************************************
' Display the status message.
' ************************************************
Private Sub DisplayStatus(msg As String, probes As Integer)
Dim ave_succ As Single
Dim ave_unsucc As Single

    ComputeAverageProbe ave_succ, ave_unsucc
    StatusLabel.Caption = msg & "   This probe:" & Str$(probes) & ".   Ave successful probe: " & Format$(ave_succ, "0.00") & ".  Ave unsuccessful probe: " & Format$(ave_unsucc, "0.00") & "."
End Sub

Private Sub Form_Load()
    Randomize
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub

' ************************************************
' Present help about the program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String

    txt = "This program demonstrates hashing with chaining. The main areas on the form are:" & vbCrLf & vbCrLf
    txt = txt & "    Table Creation: Enter the number of lists you want to create and click the Create Table button. Check the Sort Lists box if you want the lists to be sorted." & vbCrLf & vbCrLf
    txt = txt & "    Random Items: Enter the number and maximum value of the items you want created and click the Create Items button to make the program insert random items into the table." & vbCrLf & vbCrLf
    txt = txt & "    Search: Enter a value and click the Add or Find button to make the program add the item or find it in the table."
    
    MsgBox txt, vbOKOnly, "Help About ... Chain"
End Sub

Private Sub NewItem_Change()
    CmdAdd.Enabled = (Trim$(NewItem.Text) <> "")
    CmdFind.Enabled = CmdAdd.Enabled
End Sub

Private Sub TableSize_Change()
    CmdNewTable.Enabled = IsNumeric(TableSize.Text)
End Sub

