Attribute VB_Name = "LinearRehashing"
' ************************************************
' Rehash.BAS
'
' Source code for open addressing with linear
' probing example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Global Const HASH_FOUND = 0
Global Const HASH_NOT_FOUND = 1
Global Const HASH_INSERTED = 2
Global Const HASH_TABLE_FULL = 3
Global Const HASH_DELETED = 4

' This value indicates an unused entry.
Global Const UNUSED = -2147483648#
Global Const DELETED = -2147483647#

Type ItemType
    Value As Long
    Rehashed As Boolean
End Type
