VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "WorkNode"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' WorkNode.CLS
'
' Node class for work assignment example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Public Id As Integer
Public X As Single
Public Y As Single
Public Links As Collection
Public NodeStatus As Integer ' Path tree status.
Public FromNode As WorkNode  ' The node leading to this one in the tree.
Public Name As String
Public Skills As New Collection

' ************************************************
' Create a new Links collection. We do this here
' instead of simply declaring Links as:
'       Dim Links As New Collection
' so we can quickly empty the collection with:
'       Set Links = Nothing
' ************************************************
Private Sub Class_Initialize()
    Set Links = New Collection
End Sub


