VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "EllipseClass"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Cmd2.CLS
'
' Command class for command object example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Private m_X As Single
Private m_Y As Single
Private m_Radius As Single
Private m_Color As Long
Private m_Aspect As Single
Private m_Style As Integer

' ************************************************
' Execute the object's command.
' ************************************************
Public Sub Execute(pic As PictureBox)
    pic.FillStyle = m_Style
    pic.FillColor = m_Color
    pic.Circle (m_X, m_Y), m_Radius, m_Color, , , m_Aspect
End Sub

' ************************************************
' Set the object's data values.
' ************************************************
Public Sub SetValues(X1 As Single, Y1 As Single, X2 As Single, Y2 As Single, color As Long, style As Integer)
Dim dx As Single
Dim dy As Single

    m_X = (X1 + X2) / 2
    m_Y = (Y1 + Y2) / 2
    dx = Abs(X1 - X2)
    dy = Abs(Y1 - Y2)
    If dx > dy Then
        m_Radius = dx / 2
    Else
        m_Radius = dy / 2
    End If
    m_Aspect = dy / dx
    m_Color = color
    m_Style = style
End Sub

