VERSION 4.00
Begin VB.Form Command2Form 
   Caption         =   "Command2"
   ClientHeight    =   3990
   ClientLeft      =   1500
   ClientTop       =   1860
   ClientWidth     =   5910
   Height          =   4680
   Left            =   1440
   LinkTopic       =   "Form1"
   ScaleHeight     =   3990
   ScaleWidth      =   5910
   Top             =   1230
   Width           =   6030
   Begin VB.Frame Frame1 
      Caption         =   "Fill Style"
      Height          =   1335
      Index           =   2
      Left            =   0
      TabIndex        =   10
      Top             =   2640
      Width           =   1815
      Begin VB.OptionButton FillOption 
         Caption         =   "Diagonal Cross"
         Height          =   255
         Index           =   3
         Left            =   240
         TabIndex        =   14
         Tag             =   "7"
         Top             =   960
         Width           =   1455
      End
      Begin VB.OptionButton FillOption 
         Caption         =   "Cross"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   13
         Tag             =   "6"
         Top             =   720
         Width           =   1215
      End
      Begin VB.OptionButton FillOption 
         Caption         =   "Transparent"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   12
         Tag             =   "1"
         Top             =   480
         Width           =   1215
      End
      Begin VB.OptionButton FillOption 
         Caption         =   "Solid"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   11
         Tag             =   "0"
         Top             =   240
         Width           =   1215
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Color"
      Height          =   1335
      Index           =   1
      Left            =   0
      TabIndex        =   5
      Top             =   1200
      Width           =   1815
      Begin VB.OptionButton ColorOption 
         Caption         =   "Black"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   9
         Tag             =   "0"
         Top             =   240
         Width           =   1095
      End
      Begin VB.OptionButton ColorOption 
         Caption         =   "Red"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   8
         Tag             =   "255"
         Top             =   480
         Width           =   1095
      End
      Begin VB.OptionButton ColorOption 
         Caption         =   "Green"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   7
         Tag             =   "65280"
         Top             =   720
         Width           =   1095
      End
      Begin VB.OptionButton ColorOption 
         Caption         =   "Blue"
         Height          =   255
         Index           =   3
         Left            =   240
         TabIndex        =   6
         Tag             =   "16711680 "
         Top             =   960
         Width           =   1095
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Shape"
      Height          =   1095
      Index           =   0
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   1815
      Begin VB.OptionButton ShapeOption 
         Caption         =   "Line"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   4
         Top             =   720
         Width           =   1095
      End
      Begin VB.OptionButton ShapeOption 
         Caption         =   "Ellipse"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   3
         Top             =   480
         Width           =   1095
      End
      Begin VB.OptionButton ShapeOption 
         Caption         =   "Rectangle"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   2
         Top             =   240
         Value           =   -1  'True
         Width           =   1095
      End
   End
   Begin VB.PictureBox Canvas 
      Height          =   3975
      Left            =   1920
      ScaleHeight     =   3915
      ScaleWidth      =   3915
      TabIndex        =   0
      Top             =   0
      Width           =   3975
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuDraw 
      Caption         =   "&Draw"
      Begin VB.Menu mnuDrawUndo 
         Caption         =   "&Undo"
         Enabled         =   0   'False
         Shortcut        =   ^Z
      End
      Begin VB.Menu mnuDrawRedo 
         Caption         =   "&Redo"
         Enabled         =   0   'False
         Shortcut        =   ^Y
      End
      Begin VB.Menu mnuDrawClear 
         Caption         =   "&Clear"
         Shortcut        =   ^C
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "Command2Form"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Command.FRM
'
' Main form for command object example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

' A collection of command objects.
Private CmdObjects As Collection
Private LastCmd As Integer ' Index of last command.

Private StartX As Single
Private StartY As Single
Private CurX As Single
Private CurY As Single

Private Drawing As Boolean

Private SelectedColor As Long
Private SelectedFill As Integer

' ************************************************
' Create the appropriate command object.
' ************************************************
Private Sub CreateCommandObject()
Dim cmd As Object

    If ShapeOption(0).Value Then
        Set cmd = New RectangleClass
    ElseIf ShapeOption(1).Value Then
        Set cmd = New EllipseClass
    Else
        Set cmd = New LineClass
    End If
    
    ' Save the command parameters.
    cmd.SetValues StartX, StartY, CurX, CurY, _
        SelectedColor, SelectedFill

    ' If we are in the command history, remove any
    ' future commands.
    Do While CmdObjects.Count > LastCmd
        CmdObjects.Remove CmdObjects.Count
    Loop

    ' Add the command to the list of commands.
    CmdObjects.Add cmd
    LastCmd = CmdObjects.Count
    mnuDrawUndo.Enabled = True
    mnuDrawRedo.Enabled = False
End Sub

' ************************************************
' Draw the correct shape inside the bounding box.
' ************************************************
Private Sub DrawShape(X1 As Single, Y1 As Single, X2 As Single, Y2 As Single)
Dim X As Single
Dim Y As Single
Dim dx As Single
Dim dy As Single
Dim aspect As Single
Dim radius As Single

    If ShapeOption(0).Value Then
        ' Draw a rectangle.
        Canvas.Line (StartX, StartY)-(CurX, CurY), , B
    ElseIf ShapeOption(2).Value Then
        ' Draw a line.
        Canvas.Line (StartX, StartY)-(CurX, CurY)
    Else
        ' Draw a circle.
        dx = Abs(X1 - X2)
        dy = Abs(Y1 - Y2)
        If dx > 0 And dy > 0 Then
            X = (X1 + X2) / 2
            Y = (Y1 + Y2) / 2
            If dx > dy Then
                radius = dx / 2
            Else
                radius = dy / 2
            End If
            aspect = dy / dx
            Canvas.Circle (X, Y), radius, , , , aspect
        End If
    End If
End Sub

' ************************************************
' Start a rubber band operation to draw something.
' ************************************************
Private Sub Canvas_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    StartX = X
    StartY = Y
    CurX = X
    CurY = Y
    Drawing = True
    Canvas.FillStyle = vbFSTransparent
    Canvas.DrawMode = vbInvert
End Sub

' ************************************************
' Continue a rubber band operation.
' ************************************************
Private Sub Canvas_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not Drawing Then Exit Sub

    DrawShape StartX, StartY, CurX, CurY
    CurX = X
    CurY = Y
    DrawShape StartX, StartY, CurX, CurY
End Sub
' ************************************************
' Finsh a rubber band operation.
' ************************************************
Private Sub Canvas_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not Drawing Then Exit Sub
    Drawing = False

    DrawShape StartX, StartY, CurX, CurY
    Canvas.DrawMode = vbCopyPen

    CurX = X
    CurY = Y

    ' Create the appropriate command object.
    CreateCommandObject
    
    ' Redraw.
    Canvas.Refresh
End Sub
' ************************************************
' Execute all of the drawing commands.
' ************************************************
Private Sub Canvas_Paint()
Dim i As Integer

    Canvas.Cls
    For i = 1 To LastCmd
        CmdObjects(i).Execute Canvas
    Next i
End Sub


' ************************************************
' Save the selected color value.
' ************************************************
Private Sub ColorOption_Click(Index As Integer)
    SelectedColor = CLng(ColorOption(Index).Tag)
End Sub

' ************************************************
' Save the selected fill value.
' ************************************************
Private Sub FillOption_Click(Index As Integer)
    SelectedFill = CInt(FillOption(Index).Tag)
End Sub

' ************************************************
' Clear the canvas.
' ************************************************
Private Sub mnuDrawClear_Click()
    Set CmdObjects = New Collection
    LastCmd = 0
    mnuDrawUndo.Enabled = False
    mnuDrawRedo.Enabled = False

    Canvas.Refresh
End Sub

' ************************************************
' Initialize stuff.
' ************************************************
Private Sub Form_Load()
    ' Start with an empty command list.
    Set CmdObjects = New Collection
    
    ' Select initial color and fill style.
    ColorOption(0).Value = True
    FillOption(1).Value = True
End Sub

' ************************************************
' Redo the last command.
' ************************************************
Private Sub mnuDrawRedo_Click()
    LastCmd = LastCmd + 1
    If LastCmd >= CmdObjects.Count Then _
        mnuDrawRedo.Enabled = False
    mnuDrawUndo.Enabled = True
    Canvas.Refresh
End Sub

' ************************************************
' Undo the last command.
' ************************************************
Private Sub mnuDrawUndo_Click()
    LastCmd = LastCmd - 1
    If LastCmd <= 0 Then _
        mnuDrawUndo.Enabled = False
    mnuDrawRedo.Enabled = True
    Canvas.Refresh
End Sub

' ************************************************
' Present help about the program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String

    txt = "This program demonstrates command objects. Click and drag to draw shapes. When you draw a shape, the program creates a command object representing the shape. To draw, the program executes each of the shapes in turn." & vbCrLf & vbCrLf
    txt = txt & "When you select the Draw menu's Undo command, the program moves its position in the command list back one position. It then redraws, stopping before it executes the last command." & vbCrLf & vbCrLf
    txt = txt & "When you select the Draw menu's Redo command, the program moves its position in the command list forward one position."

    MsgBox txt, vbOKOnly, "Help About ... Command2"
End Sub

' ************************************************
' Quit.
' ************************************************
Private Sub mnuFileExit_Click()
    Unload Me
End Sub


