VERSION 4.00
Begin VB.Form InheritForm 
   Caption         =   "Inherit"
   ClientHeight    =   2685
   ClientLeft      =   2865
   ClientTop       =   1935
   ClientWidth     =   2430
   Height          =   3375
   Left            =   2805
   LinkTopic       =   "Form1"
   ScaleHeight     =   2685
   ScaleWidth      =   2430
   Top             =   1305
   Width           =   2550
   Begin VB.TextBox EmpText 
      BackColor       =   &H8000000F&
      Height          =   2655
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   0
      Width           =   2415
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "InheritForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Inherit.FRM
'
' Main form for delegation example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Private Sub Form_Resize()
    EmpText.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

' ************************************************
' Present help about the program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String

    txt = "This program demonstrates delegation. It begins by creating one Employee and one Manager object. It then uses the TextValues function to display the objects textually." & vbCrLf & vbCrLf
    txt = txt & "The Manager class delegates responsibilities to a contained Employee object."

    MsgBox txt, vbOKOnly, "Help About ... Inherit"
End Sub
' ************************************************
' Create two objects.
' ************************************************
Private Sub Form_Load()
Dim objs(1 To 3) As Object
Dim i As Integer
Dim txt As String

    ' Create an Employee object.
    Set objs(1) = New Employee
    objs(1).Name = "Mr. Employee"
    objs(1).Salary = 40000
    objs(1).SSN = "123-45-6789"
    
    ' Create a Manager object.
    Set objs(2) = New Manager
    objs(2).Name = "Ms. Manager"
    objs(2).Salary = 70000
    objs(2).SSN = "111-22-3333"
    objs(2).Secretary = "Robo Secretary"
    
    ' Create another Employee object.
    Set objs(3) = New Employee
    objs(3).Name = "Another Employee"
    objs(3).Salary = 30000
    objs(3).SSN = "444-55-6666"
    
    ' Display the objects textually.
    For i = 1 To 3
        txt = txt & objs(i).TextValues & vbCrLf
    Next i
    EmpText.Text = txt
End Sub

' ************************************************
' Quit.
' ************************************************
Private Sub mnuFileExit_Click()
    Unload Me
End Sub

