VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Manager"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Manager.CLS
'
' Manager class for delegation example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Private m_Employee As New Employee

Private m_Secretary As String
Property Let Secretary(New_Secretary As String)
    m_Secretary = New_Secretary
End Property

Property Let Name(New_Name As String)
    m_Employee.Name = New_Name
End Property
Property Let SSN(New_SSN As String)
    m_Employee.SSN = New_SSN
End Property
Property Let Salary(New_Salary As Long)
    m_Employee.Salary = New_Salary
End Property
Property Get Salary() As Long
    Salary = m_Employee.Salary
End Property
Public Function TextValues() As String
Dim txt As String

    txt = m_Employee.TextValues
    txt = txt & "    " & m_Secretary & vbCrLf
    TextValues = txt
End Function
Property Get Name() As String
    Name = m_Employee.Name
End Property
Property Get SSN() As String
    SSN = m_Employee.SSN
End Property
Property Get Secretary() As String
    Secretary = m_Secretary
End Property

