VERSION 4.00
Begin VB.Form ShapesForm 
   Caption         =   "Shapes"
   ClientHeight    =   3990
   ClientLeft      =   1500
   ClientTop       =   1860
   ClientWidth     =   5910
   Height          =   4680
   Left            =   1440
   LinkTopic       =   "Form1"
   ScaleHeight     =   3990
   ScaleWidth      =   5910
   Top             =   1230
   Width           =   6030
   Begin VB.Frame Frame1 
      Caption         =   "Fill Style"
      Height          =   1335
      Index           =   2
      Left            =   0
      TabIndex        =   10
      Top             =   2640
      Width           =   1815
      Begin VB.OptionButton FillOption 
         Caption         =   "Diagonal Cross"
         Height          =   255
         Index           =   3
         Left            =   240
         TabIndex        =   14
         Tag             =   "7"
         Top             =   960
         Width           =   1455
      End
      Begin VB.OptionButton FillOption 
         Caption         =   "Cross"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   13
         Tag             =   "6"
         Top             =   720
         Width           =   1215
      End
      Begin VB.OptionButton FillOption 
         Caption         =   "Transparent"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   12
         Tag             =   "1"
         Top             =   480
         Width           =   1215
      End
      Begin VB.OptionButton FillOption 
         Caption         =   "Solid"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   11
         Tag             =   "0"
         Top             =   240
         Width           =   1215
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Color"
      Height          =   1335
      Index           =   1
      Left            =   0
      TabIndex        =   5
      Top             =   1200
      Width           =   1815
      Begin VB.OptionButton ColorOption 
         Caption         =   "Black"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   9
         Tag             =   "0"
         Top             =   240
         Width           =   1095
      End
      Begin VB.OptionButton ColorOption 
         Caption         =   "Red"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   8
         Tag             =   "255"
         Top             =   480
         Width           =   1095
      End
      Begin VB.OptionButton ColorOption 
         Caption         =   "Green"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   7
         Tag             =   "65280"
         Top             =   720
         Width           =   1095
      End
      Begin VB.OptionButton ColorOption 
         Caption         =   "Blue"
         Height          =   255
         Index           =   3
         Left            =   240
         TabIndex        =   6
         Tag             =   "16711680 "
         Top             =   960
         Width           =   1095
      End
   End
   Begin VB.PictureBox Canvas 
      Height          =   3975
      Left            =   1920
      ScaleHeight     =   3915
      ScaleWidth      =   3915
      TabIndex        =   0
      Top             =   0
      Width           =   3975
   End
   Begin VB.Frame Frame1 
      Caption         =   "Shape"
      Height          =   1095
      Index           =   0
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   1815
      Begin VB.OptionButton ShapeOption 
         Caption         =   "Line"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   4
         Tag             =   "LineCmd"
         Top             =   720
         Width           =   1095
      End
      Begin VB.OptionButton ShapeOption 
         Caption         =   "Ellipse"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   3
         Tag             =   "EllipseCmd"
         Top             =   480
         Width           =   1095
      End
      Begin VB.OptionButton ShapeOption 
         Caption         =   "Rectangle"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   2
         Tag             =   "RectangleCmd"
         Top             =   240
         Width           =   1095
      End
   End
   Begin MSComDlg.CommonDialog FileDialog 
      Left            =   1440
      Top             =   840
      _Version        =   65536
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      CancelError     =   -1  'True
      DefaultExt      =   ".shp"
      DialogTitle     =   "Shapes File"
      Filter          =   "Shape Files (*.shp)|*.shp|All Files (*.*)|*.*"
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileNew 
         Caption         =   "&New"
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open..."
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileSave 
         Caption         =   "&Save"
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuFileSaveAs 
         Caption         =   "Save &As..."
         Shortcut        =   ^A
      End
      Begin VB.Menu mnuFileSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuDraw 
      Caption         =   "&Draw"
      Begin VB.Menu mnuDrawUndo 
         Caption         =   "&Undo"
         Enabled         =   0   'False
         Shortcut        =   ^Z
      End
      Begin VB.Menu mnuDrawRedo 
         Caption         =   "&Redo"
         Enabled         =   0   'False
         Shortcut        =   ^Y
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "ShapesForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Shapes.FRM
'
' Main form for command object example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Private StartX As Single
Private StartY As Single
Private CurX As Single
Private CurY As Single

Private Drawing As Boolean

Private SelectedColor As Long
Private SelectedFill As Integer

Private FileName As String
Private SelectedCommand As String

Private ThePicture As New ShapePicture
' ************************************************
' Create the appropriate command object.
' ************************************************
Private Sub MakeObject()
Dim cmd As Object

    Set cmd = ThePicture.CommandFactory(SelectedCommand)
    
    ' Save the command parameters.
    cmd.SetValues StartX, StartY, CurX, CurY, _
        SelectedColor, SelectedFill

    ' Enable the proper menu items.
    mnuDrawUndo.Enabled = ThePicture.CanUndo
    mnuDrawRedo.Enabled = ThePicture.CanRedo
End Sub

' ************************************************
' Draw the correct shape inside the bounding box.
' ************************************************
Private Sub DrawShape(x1 As Single, y1 As Single, x2 As Single, y2 As Single)
Dim X As Single
Dim Y As Single
Dim dx As Single
Dim dy As Single
Dim aspect As Single
Dim radius As Single

    Select Case SelectedCommand
        Case "EllipseCmd"
            dx = Abs(x1 - x2)
            dy = Abs(y1 - y2)
            If dx > 0 And dy > 0 Then
                X = (x1 + x2) / 2
                Y = (y1 + y2) / 2
                If dx > dy Then
                    radius = dx / 2
                Else
                    radius = dy / 2
                End If
                aspect = dy / dx
                Canvas.Circle (X, Y), radius, , , , aspect
            End If
        Case "LineCmd"
            Canvas.Line (StartX, StartY)-(CurX, CurY)
        Case "RectangleCmd"
            Canvas.Line (StartX, StartY)-(CurX, CurY), , B
    End Select
End Sub
' ************************************************
' Load a shape file.
' ************************************************
Private Sub LoadShapes(fname As String)
Dim fnum As Integer
Dim txt As String

    On Error GoTo LoadError
    
    ' Open the file.
    fnum = FreeFile
    Open fname For Input Access Read As fnum

    ' Read the serialization.
    txt = Input(LOF(fnum), fnum)

    ' Close the file.
    Close #fnum
    
    ' Initialize the picture.
    ThePicture.Serialization = txt
    Exit Sub

LoadError:
    Beep
    MsgBox "Error" & Str$(Err.Number) & _
        " loading file """ & fname & _
        """." & vbCrLf & Err.Description
    Exit Sub
End Sub
' ************************************************
' Save a shape file.
' ************************************************
Private Sub SaveShapes(fname As String)
Dim fnum As Integer
Dim txt As String

    On Error GoTo SaveError

    ' Open the file.
    fnum = FreeFile
    Open fname For Output Access Write As fnum

    ' Create the serialization.
    txt = ThePicture.Serialization

    ' Write the serialization.
    Print #fnum, txt

    ' Close the file.
    Close #fnum
    Exit Sub

SaveError:
    Beep
    MsgBox "Error" & Str$(Err.Number) & _
        " saving file """ & fname & _
        """." & vbCrLf & Err.Description
    Exit Sub
End Sub

' ************************************************
' Start a rubber band operation to draw something.
' ************************************************
Private Sub Canvas_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    StartX = X
    StartY = Y
    CurX = X
    CurY = Y
    Drawing = True
    Canvas.FillStyle = vbFSTransparent
    Canvas.DrawMode = vbInvert
End Sub

' ************************************************
' Continue a rubber band operation.
' ************************************************
Private Sub Canvas_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not Drawing Then Exit Sub

    DrawShape StartX, StartY, CurX, CurY
    CurX = X
    CurY = Y
    DrawShape StartX, StartY, CurX, CurY
End Sub
' ************************************************
' Finsh a rubber band operation.
' ************************************************
Private Sub Canvas_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not Drawing Then Exit Sub
    Drawing = False

    DrawShape StartX, StartY, CurX, CurY
    Canvas.DrawMode = vbCopyPen

    CurX = X
    CurY = Y

    ' Create the appropriate command object.
    MakeObject

    ' Redraw.
    Canvas.Refresh
End Sub
' ************************************************
' Execute all of the drawing commands.
' ************************************************
Private Sub Canvas_Paint()
    ThePicture.Draw Canvas
End Sub

' ************************************************
' Save the selected color value.
' ************************************************
Private Sub ColorOption_Click(Index As Integer)
    SelectedColor = CLng(ColorOption(Index).Tag)
End Sub

' ************************************************
' Save the selected fill value.
' ************************************************
Private Sub FillOption_Click(Index As Integer)
    SelectedFill = CInt(FillOption(Index).Tag)
End Sub

' ************************************************
' Initialize stuff.
' ************************************************
Private Sub Form_Load()
    ' Select initial command, color, and fill style.
    ShapeOption(0).Value = True
    ColorOption(0).Value = True
    FillOption(1).Value = True
    
    FileDialog.InitDir = App.Path
    
    ThePicture.NewPicture
    mnuDrawUndo.Enabled = ThePicture.CanUndo
    mnuDrawRedo.Enabled = ThePicture.CanRedo
    Canvas.Refresh
End Sub

' ************************************************
' Redo the last command.
' ************************************************
Private Sub mnuDrawRedo_Click()
    ThePicture.Redo
    mnuDrawUndo.Enabled = ThePicture.CanUndo
    mnuDrawRedo.Enabled = ThePicture.CanRedo
    Canvas.Refresh
End Sub

' ************************************************
' Undo the last command.
' ************************************************
Private Sub mnuDrawUndo_Click()
    ThePicture.Undo
    mnuDrawUndo.Enabled = ThePicture.CanUndo
    mnuDrawRedo.Enabled = ThePicture.CanRedo
    Canvas.Refresh
End Sub

' ************************************************
' Start a new picture.
' ************************************************
Private Sub mnuFileNew_Click()
    ThePicture.NewPicture
    mnuDrawUndo.Enabled = ThePicture.CanUndo
    mnuDrawRedo.Enabled = ThePicture.CanRedo
    Canvas.Refresh
    FileName = ""
End Sub

' ************************************************
' Load a shapes file.
' ************************************************
Private Sub mnuFileOpen_Click()
Dim status As Long

    ' Prepare the file selection dialog
    FileDialog.Flags = cdlOFNFileMustExist
    FileDialog.FileName = ""
    
    On Error Resume Next
    FileDialog.ShowOpen
    status = Err
    On Error GoTo 0

    If status = cdlCancel Then Exit Sub
    If status <> 0 Then
        Beep
        MsgBox "Error" & Str$(status) & _
            " selecting file." & vbCrLf & _
            Error(status)
        Exit Sub
    End If

    FileName = FileDialog.FileName
    FileDialog.InitDir = _
        Left$(FileName, Len(FileName) - _
            Len(FileDialog.FileTitle))

    ' Load the file.
    LoadShapes FileName

    ' Display the shapes.
    mnuDrawUndo.Enabled = ThePicture.CanUndo
    mnuDrawRedo.Enabled = ThePicture.CanRedo
    Canvas.Refresh
End Sub
' ************************************************
' Save the file using the current FileName.
' ************************************************
Private Sub mnuFileSave_Click()
    ' Make sure we have a file name.
    If FileName = "" Then
        mnuFileSaveAs_Click
        Exit Sub
    End If
    
    ' Save the picture.
    SaveShapes FileName
End Sub
' ************************************************
' Save the picture in a file selected by the user.
' ************************************************
Private Sub mnuFileSaveAs_Click()
Dim status As Long

    ' Prepare the file selection dialog
    FileDialog.Flags = cdlOFNOverwritePrompt
    FileDialog.FileName = ""

    On Error Resume Next
    FileDialog.ShowSave
    status = Err
    On Error GoTo 0

    If status = cdlCancel Then Exit Sub
    If status <> 0 Then
        Beep
        MsgBox "Error" & Str$(status) & _
            " selecting file." & vbCrLf & _
            Error(status)
        Exit Sub
    End If

    FileName = FileDialog.FileName
    FileDialog.InitDir = _
        Left$(FileName, Len(FileName) - _
            Len(FileDialog.FileTitle))

    ' Save the picture.
    SaveShapes FileDialog.FileName
End Sub
' ************************************************
' Present help about the program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String

    txt = "This program uses serializable command objects to save and restore shapes. Click and drag to draw shapes."

    MsgBox txt, vbOKOnly, "Help About ... Shapes"
End Sub

' ************************************************
' Quit.
' ************************************************
Private Sub mnuFileExit_Click()
    Unload Me
End Sub


' ************************************************
' Save the selected command name.
' ************************************************
Private Sub ShapeOption_Click(Index As Integer)
    SelectedCommand = ShapeOption(Index).Tag
End Sub


