VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "WindowListerClass"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' WinList.CLS
'
' WindowListerClass class.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

#If Win32 Then
    Private Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long
    Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
    Private Declare Function GetDesktopWindow Lib "user32" () As Long
#Else
    Private Declare Function GetWindow Lib "User" (ByVal hwnd As Integer, ByVal wCmd As Integer) As Integer
    Private Declare Function GetWindowText Lib "User" (ByVal hwnd As Integer, ByVal lpString As String, ByVal aint As Integer) As Integer
    Private Declare Function GetDesktopWindow Lib "User" () As Integer
#End If

Private Const GW_CHILD = 5
Private Const GW_HWNDNEXT = 2

Private TheHwnd As Long
' ************************************************
' Return a list of windows.
' ************************************************
Property Get WindowList() As String
Dim next_hWnd As Long
Dim txt As String
Dim buf As String * 200
Dim buflen As Integer

    txt = "  hWnd Title" & vbCrLf & "------ -----"
    next_hWnd = GetWindow(TheHwnd, GW_CHILD)
    Do While next_hWnd <> 0
        buflen = GetWindowText(next_hWnd, buf, Len(buf) - 1)
        If buflen > 0 Then _
            txt = txt & vbCrLf & _
                Format$(next_hWnd, "@@@@@@") & _
                " " & Left$(buf, buflen)
        next_hWnd = GetWindow(next_hWnd, GW_HWNDNEXT)
    Loop
    
    WindowList = txt
End Property

Private Sub Class_Initialize()
    TheHwnd = GetDesktopWindow()
End Sub


