VERSION 4.00
Begin VB.Form DblLinkForm 
   Appearance      =   0  'Flat
   Caption         =   "DblLink"
   ClientHeight    =   5865
   ClientLeft      =   3015
   ClientTop       =   750
   ClientWidth     =   3015
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   6555
   Icon            =   "DblLink.frx":0000
   Left            =   2955
   ScaleHeight     =   5865
   ScaleWidth      =   3015
   Top             =   120
   Width           =   3135
   Begin VB.CommandButton CmdAddBefore 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Add Before"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   6
      Top             =   840
      Width           =   1455
   End
   Begin VB.CommandButton CmdClearList 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Cancel          =   -1  'True
      Caption         =   "Clear List"
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   5
      Top             =   2640
      Width           =   1455
   End
   Begin VB.CommandButton CmdRemove 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Remove"
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   4
      Top             =   2040
      Width           =   1455
   End
   Begin VB.CommandButton CmdAddAfter 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Add After"
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   1440
      Width           =   1455
   End
   Begin VB.TextBox NewItem 
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   1455
   End
   Begin VB.Label AllList 
      Appearance      =   0  'Flat
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Sentinel"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   1
      Left            =   1680
      TabIndex        =   7
      Top             =   275
      Width           =   1215
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackStyle       =   0  'Transparent
      Caption         =   "New Item"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   0
      Width           =   855
   End
   Begin VB.Label AllList 
      Appearance      =   0  'Flat
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Sentinel"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   0
      Left            =   1680
      TabIndex        =   3
      Top             =   0
      Width           =   1215
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "DblLinkForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' DblLink.FRM
'
' Main form for doubly linked list program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Dim TopSentinel As New DoubleListCell     ' The list top.
Dim BottomSentinel As New DoubleListCell  ' The list bottom.
Dim NumItems As Long          ' The number of items.

Dim SelectedIndex As Integer

Dim MaxEntries As Long  ' Last loaded label control.

' ************************************************
' Select an item.
' ************************************************
Private Sub SelectItem(ByVal Index As Integer)
    ' Deselect the previous item.
    If SelectedIndex >= 0 Then
        AllList(SelectedIndex).ForeColor = Label1.ForeColor
        AllList(SelectedIndex).BackColor = Label1.BackColor
    End If
    
    ' Select the new item.
    SelectedIndex = Index
    If SelectedIndex >= 0 Then
        AllList(SelectedIndex).ForeColor = Label1.BackColor
        AllList(SelectedIndex).BackColor = Label1.ForeColor
    End If
End Sub

' ************************************************
' Set button editability.
' ************************************************
Private Sub SetButtons()
    CmdAddAfter.Enabled = _
        (Trim$(NewItem.Text) <> "") And _
        SelectedIndex >= 0 And _
        SelectedIndex <= NumItems
    CmdAddBefore.Enabled = _
        (Trim$(NewItem.Text) <> "") And _
        SelectedIndex >= 1 And _
        SelectedIndex <= NumItems + 1
    CmdRemove.Enabled = _
        SelectedIndex <= NumItems And _
        SelectedIndex > 0
    CmdClearList.Enabled = NumItems > 0
End Sub

' ************************************************
' Select this item.
' ************************************************
Private Sub AllList_Click(Index As Integer)
    SelectItem Index
    SetButtons
End Sub

' ************************************************
' Add the new item to the list.
' ************************************************
Private Sub CmdAddAfter_Click()
Dim position As Long
Dim after_me As DoubleListCell
Dim before_me As DoubleListCell
Dim new_cell As New DoubleListCell

    ' Find the cell (could be TopSentinel).
    Set after_me = TopSentinel
    position = SelectedIndex
    Do While position > 0
        position = position - 1
        Set after_me = after_me.NextCell
    Loop

    ' Add the new item.
    new_cell.Value = NewItem.Text
    Set before_me = after_me.NextCell
    Set after_me.NextCell = new_cell
    Set new_cell.NextCell = before_me
    Set before_me.PrevCell = new_cell
    Set new_cell.PrevCell = after_me
    
    NumItems = NumItems + 1

    DisplayList
    SelectItem SelectedIndex + 1 ' Select the new item.
    NewItem.Text = ""
    NewItem.SetFocus
    SetButtons
End Sub

Private Sub CmdAddBefore_Click()
Dim position As Long
Dim after_me As DoubleListCell
Dim before_me As DoubleListCell
Dim new_cell As New DoubleListCell

    ' Find the cell (could be BottomSentinel).
    Set before_me = TopSentinel.NextCell
    position = SelectedIndex - 1
    Do While position > 0
        position = position - 1
        Set before_me = before_me.NextCell
    Loop

    ' Add the new item.
    new_cell.Value = NewItem.Text
    Set after_me = before_me.PrevCell
    Set after_me.NextCell = new_cell
    Set new_cell.NextCell = before_me
    Set before_me.PrevCell = new_cell
    Set new_cell.PrevCell = after_me
    
    NumItems = NumItems + 1

    DisplayList
    SelectItem SelectedIndex ' Select the new item.
    NewItem.Text = ""
    NewItem.SetFocus
    SetButtons
End Sub

' ************************************************
' Clear the list.
' ************************************************
Private Sub CmdClearList_Click()
Dim ptr As DoubleListCell

    ' Clear the PrevCell pointers to remove
    ' circular references.
    Set ptr = TopSentinel.NextCell
    Do While Not (ptr Is BottomSentinel)
        Set ptr.PrevCell = Nothing
        Set ptr = ptr.NextCell
    Loop
    
    ' Remove the items.
    Set TopSentinel.NextCell = BottomSentinel
    Set BottomSentinel.PrevCell = TopSentinel
    NumItems = 0
    
    SelectItem -1   ' Deselect any item.
    DisplayList
    NewItem.SetFocus
    SetButtons
End Sub

' ************************************************
' Remove the selected item from the list.
' ************************************************
Private Sub CmdRemove_Click()
Dim position As Integer
Dim after_target As DoubleListCell
Dim before_target As DoubleListCell
Dim target As DoubleListCell

    If SelectedIndex < 0 Then Exit Sub
    
    ' Find the target.
    Set target = TopSentinel.NextCell
    position = SelectedIndex - 1
    Do While position > 0
        position = position - 1
        Set target = target.NextCell
    Loop
    
    ' Remove the item.
    Set after_target = target.NextCell
    Set before_target = target.PrevCell
    Set before_target.NextCell = after_target
    Set after_target.PrevCell = before_target

    NumItems = NumItems - 1
    
    SelectItem -1   ' Deselect the item.
    DisplayList
    NewItem.SetFocus
    SetButtons
End Sub
' ************************************************
' Display the list.
' ************************************************
Private Sub DisplayList()
Const YGAP = 20
Const XGAP = 120

Dim i As Long
Dim ptr As DoubleListCell

    ' Create control array entries if needed
    For i = MaxEntries + 1 To NumItems + 1
        Load AllList(i)
        AllList(i).Top = AllList(i - 1).Top + _
            AllList(i - 1).Height + YGAP
        If AllList(i).Top + AllList(i).Height > _
            ScaleHeight _
        Then
            AllList(i).Top = AllList(0).Top + _
                AllList(0).Height + YGAP
            AllList(i).Left = AllList(i - 1).Left + _
                AllList(i - 1).Width + XGAP
        Else
            AllList(i).Left = AllList(i - 1).Left
        End If
        AllList(i).ForeColor = Label1.ForeColor
        AllList(i).BackColor = Label1.BackColor
    Next i
    If MaxEntries < NumItems + 1 Then _
        MaxEntries = NumItems + 1
    
    ' Display used items
    Set ptr = TopSentinel.NextCell
    For i = 1 To NumItems
        AllList(i).Caption = Format$(i) & _
            ": " & ptr.Value
        AllList(i).Visible = True
        Set ptr = ptr.NextCell
    Next i
    
    ' Show the bottom sentinel.
    AllList(NumItems + 1).Caption = "Sentinel"
    AllList(NumItems + 1).Visible = True

    ' Hide unneeded list entries.
    For i = NumItems + 2 To MaxEntries
        AllList(i).Visible = False
    Next i
End Sub


Private Sub Form_Load()
    SelectedIndex = -1
    
    ' Initialize the empty list.
    Set TopSentinel.NextCell = BottomSentinel
    Set BottomSentinel.PrevCell = TopSentinel
    
    MaxEntries = 1
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub

' ************************************************
' Present help about this program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String

    txt = txt & "This program demonstrates a doubly linked list." & vbCrLf & vbCrLf
    txt = txt & "Enter a value and click on an item in the list. Then click Add Before to add the item before the one you selected. Click Add After to add the item after the one you selected." & vbCrLf & vbCrLf
    txt = txt & "Click an item in the list and click Remove to remove the item."

    MsgBox txt, vbOKOnly, "Help About ... DblLink"
End Sub

' *******************************************************
' Enable the Add button if the item is not blank
' and an item has been selected.
' *******************************************************
Private Sub NewItem_Change()
    SetButtons
End Sub

