VERSION 4.00
Begin VB.Form ThreadedListForm 
   Appearance      =   0  'Flat
   Caption         =   "Threads"
   ClientHeight    =   5055
   ClientLeft      =   1590
   ClientTop       =   1215
   ClientWidth     =   5430
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   5745
   Icon            =   "Threads.frx":0000
   Left            =   1530
   ScaleHeight     =   5055
   ScaleWidth      =   5430
   Top             =   585
   Width           =   5550
   Begin VB.TextBox ListText 
      BackColor       =   &H8000000F&
      Height          =   5055
      Left            =   3240
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   11
      Top             =   0
      Width           =   2175
   End
   Begin VB.Frame Frame1 
      Caption         =   "Ordering"
      Height          =   2175
      Index           =   1
      Left            =   0
      TabIndex        =   18
      Top             =   2880
      Width           =   3135
      Begin VB.OptionButton OrderOption 
         Caption         =   "Name"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   6
         TabStop         =   0   'False
         Top             =   360
         Value           =   -1  'True
         Width           =   2055
      End
      Begin VB.OptionButton OrderOption 
         Caption         =   "Job Class (reversed)"
         Height          =   255
         Index           =   4
         Left            =   240
         TabIndex        =   10
         TabStop         =   0   'False
         Top             =   1800
         Width           =   2055
      End
      Begin VB.OptionButton OrderOption 
         Caption         =   "Job Class"
         Height          =   255
         Index           =   3
         Left            =   240
         TabIndex        =   9
         TabStop         =   0   'False
         Top             =   1440
         Width           =   2055
      End
      Begin VB.OptionButton OrderOption 
         Caption         =   "Soc Sec #"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   8
         TabStop         =   0   'False
         Top             =   1080
         Width           =   2055
      End
      Begin VB.OptionButton OrderOption 
         Caption         =   "Name (reversed)"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   7
         TabStop         =   0   'False
         Top             =   720
         Width           =   2055
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "New Data"
      Height          =   2775
      Index           =   0
      Left            =   0
      TabIndex        =   12
      Top             =   0
      Width           =   3135
      Begin VB.TextBox FirstNameText 
         Height          =   315
         Left            =   1200
         TabIndex        =   1
         Top             =   600
         Width           =   1815
      End
      Begin VB.CommandButton CmdAdd 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         Caption         =   "Add"
         Default         =   -1  'True
         Height          =   495
         Left            =   960
         TabIndex        =   5
         Top             =   2160
         Width           =   975
      End
      Begin VB.TextBox LastNameText 
         Height          =   315
         Left            =   1200
         TabIndex        =   0
         Top             =   240
         Width           =   1815
      End
      Begin VB.TextBox SSNText 
         Height          =   315
         Left            =   1200
         MaxLength       =   11
         TabIndex        =   2
         Top             =   960
         Width           =   1215
      End
      Begin VB.TextBox SexText 
         Height          =   315
         Left            =   1200
         MaxLength       =   1
         TabIndex        =   3
         Top             =   1320
         Width           =   255
      End
      Begin VB.TextBox JobClassText 
         Height          =   315
         Left            =   1200
         MaxLength       =   2
         TabIndex        =   4
         Top             =   1680
         Width           =   375
      End
      Begin VB.Label Label1 
         Caption         =   "First Name"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   17
         Top             =   600
         Width           =   975
      End
      Begin VB.Label Label1 
         Caption         =   "Last Name"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   16
         Top             =   240
         Width           =   975
      End
      Begin VB.Label Label1 
         Caption         =   "SSN"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   15
         Top             =   960
         Width           =   975
      End
      Begin VB.Label Label1 
         Caption         =   "Sex"
         Height          =   255
         Index           =   3
         Left            =   240
         TabIndex        =   14
         Top             =   1320
         Width           =   975
      End
      Begin VB.Label Label1 
         Caption         =   "Job Class"
         Height          =   255
         Index           =   4
         Left            =   240
         TabIndex        =   13
         Top             =   1680
         Width           =   975
      End
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "ThreadedListForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Threads.FRM
'
' Main form for threaded linked list program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************

Option Explicit

Dim TList As New ThreadedList   ' The list.

Dim OrderSelected As Integer

' ************************************************
' Add the new item to the list.
' ************************************************
Private Sub CmdAdd_Click()
    TList.AddItem LastNameText.Text, _
        FirstNameText.Text, SSNText.Text, _
        SexText.Text, JobClassText.Text

    DisplayList
    
    LastNameText.Text = ""
    FirstNameText.Text = ""
    SSNText.Text = ""
    SexText.Text = ""
    JobClassText.Text = ""
    LastNameText.SetFocus
End Sub

' ************************************************
' Display the list.
' ************************************************
Private Sub DisplayList()
Dim ptr As ThreadedCell
Dim txt As String

    TList.MoveFirst OrderSelected
    Set ptr = TList.CurrentItem
    Do While Not TList.EndOfList
        txt = txt & ptr.LastName & ", " & ptr.FirstName & vbCrLf
        txt = txt & "    SSN: " & ptr.SSN & vbCrLf
        txt = txt & "    Sex: " & ptr.Sex & vbCrLf
        txt = txt & "    job class:" & ptr.JobClass & vbCrLf & vbCrLf
    
        TList.MoveNext OrderSelected
        Set ptr = TList.CurrentItem
    Loop

    ListText.Text = txt
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub

' ************************************************
' Present help about this program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String

    txt = txt & "This program demonstrates a threaded linked list." & vbCrLf & vbCrLf
    txt = txt & "Enter values and click the Add button to add an entry to the list." & vbCrLf & vbCrLf
    txt = txt & "Select an ordering option to change the order in which the list is displayed."

    MsgBox txt, vbOKOnly, "Help About ... Threads"
End Sub

' ************************************************
' Redisplay the list using the new ordering.
' ************************************************
Private Sub OrderOption_Click(Index As Integer)
    OrderSelected = Index
    DisplayList
End Sub


