VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "LinkedListStack"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ***********************************************
' Stack2.CLS
'
' Linked list stack class.
' ***********************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ***********************************************
Option Explicit

Private Top As StackCell
' ***********************************************
' Return the top item from the stack.
' ***********************************************
Property Get Pop() As String
    If Top Is Nothing Then
        Pop = ""
    Else
        Pop = Top.Value
        Set Top = Top.NextCell
    End If
End Property
' ***********************************************
' Puch a value onto the stack.
' ***********************************************
Public Sub Push(Value As String)
Dim cell As New StackCell

    cell.Value = Value
    Set cell.NextCell = Top
    Set Top = cell
End Sub


' ***********************************************
' Return true if the stack is empty.
' ***********************************************
Property Get StackEmpty() As Boolean
    StackEmpty = (Top Is Nothing)
End Property


' ***********************************************
' Return a string showing the items in the stack.
' ***********************************************
Property Get TextRepresentation() As String
Dim txt As String
Dim cell As StackCell

    Set cell = Top
    Do While Not (cell Is Nothing)
        txt = txt & cell.Value & vbCrLf
        Set cell = cell.NextCell
    Loop
    TextRepresentation = txt
End Property
