VERSION 4.00
Begin VB.Form BigAddForm 
   Appearance      =   0  'Flat
   Caption         =   "BigAdd"
   ClientHeight    =   1605
   ClientLeft      =   2700
   ClientTop       =   2160
   ClientWidth     =   2880
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   2295
   Icon            =   "BigAdd.frx":0000
   Left            =   2640
   LinkTopic       =   "FactorialForm"
   ScaleHeight     =   1605
   ScaleWidth      =   2880
   Top             =   1530
   Width           =   3000
   Begin VB.CommandButton CmdGo 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   495
      Left            =   840
      TabIndex        =   1
      Top             =   960
      Width           =   1215
   End
   Begin VB.TextBox NText 
      Height          =   285
      Left            =   1080
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
   Begin VB.Label BigAddLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   1080
      TabIndex        =   4
      Top             =   480
      Width           =   1575
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "BigAdd(N)"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   975
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "N"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   255
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "BigAddForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' BigAdd.FRM
'
' Recursive number adding example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

' ************************************************
' Recursively compute 1 + 2 + ... + N.
' ************************************************
Private Function BigAdd(N As Long) As Double
    If N <= 1 Then
        BigAdd = 1
    Else
        BigAdd = N + BigAdd(N - 1)
    End If
End Function

' *******************************************************
' Start the calculation.
' *******************************************************
Private Sub CmdGo_Click()
Dim N As Long
Dim value As Double
Dim status As Integer

    BigAddLabel.Caption = ""
    If IsNumeric(NText.Text) Then
        N = CLng(NText.Text)
        On Error Resume Next
        MousePointer = vbHourglass
        DoEvents
        value = BigAdd(N)
        MousePointer = vbDefault
        status = Err
        If status = 0 Then
            BigAddLabel.Caption = Format$(value)
        Else
            Beep
            MsgBox Error$(status), , "Error"
        End If
    Else
        Beep
    End If
End Sub


Private Sub mnuFileExit_Click()
    End
End Sub

' *******************************************************
' Present help about this program.
' *******************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program computes the sum 1 + 2 + 3 + ... + N recursively." & vbCrLf & vbCrLf
    txt = txt & "Enter a value and click the Go button to calculate the sum." & vbCrLf & vbCrLf
    txt = txt & "Note that this function can more easily be computed by:" & vbCrLf
    txt = txt & "    N * (N + 1) / 2."

    MsgBox txt, vbOKOnly, "Help About ... BigAdd"
End Sub

