VERSION 4.00
Begin VB.Form FactorialForm 
   Appearance      =   0  'Flat
   Caption         =   "Facto"
   ClientHeight    =   1650
   ClientLeft      =   2985
   ClientTop       =   2145
   ClientWidth     =   2880
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   2340
   Icon            =   "Facto.frx":0000
   Left            =   2925
   LinkTopic       =   "FactorialForm"
   ScaleHeight     =   1650
   ScaleWidth      =   2880
   Top             =   1515
   Width           =   3000
   Begin VB.CommandButton CmdGo 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   495
      Left            =   840
      TabIndex        =   2
      Top             =   960
      Width           =   1215
   End
   Begin VB.TextBox NText 
      Height          =   285
      Left            =   360
      TabIndex        =   0
      Top             =   120
      Width           =   495
   End
   Begin VB.Label NFactorialLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   360
      TabIndex        =   4
      Top             =   480
      Width           =   2415
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "N!"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   255
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "N"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   255
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "FactorialForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Facto.FRM
'
' Recursive factorial example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

' *******************************************************
' Perform the computation.
' *******************************************************
Private Sub CmdGo_Click()
Dim N As Double
Dim NFactorial As Double
Dim status As Integer

    If Not IsNumeric(NText.Text) Then
        Beep
        Exit Sub
    End If
    
    NFactorialLabel.Caption = ""
        
    N = CInt(NText.Text)
    
    On Error Resume Next
    NFactorial = Factorial(N)
    status = Err
    If status = 0 Then
        NFactorialLabel.Caption = Format$(NFactorial)
    Else
        Beep
        MsgBox Error$(status), , "Error"
    End If
End Sub

' ************************************************
' Recursively compute the factorial of a number.
' ************************************************
Private Function Factorial(ByVal N As Double) As Double
    If N <= 1 Then
        Factorial = 1
    Else
        Factorial = N * Factorial(N - 1)
    End If
End Function

Private Sub mnuFileExit_Click()
    End
End Sub

' *******************************************************
' Present help about this program.
' *******************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program computes factorials recursively using the definition:" & vbCrLf & vbCrLf
    txt = txt & "    0! = 1" & vbCrLf
    txt = txt & "    N! = N * (N - 1)!        for N > 0" & vbCrLf & vbCrLf
    txt = txt & "Enter a value and click the Go button to calculate the factorial."

    MsgBox txt, vbOKOnly, "Help About ... Facto"
End Sub


