VERSION 4.00
Begin VB.Form QueuesForm 
   Caption         =   "Priority"
   ClientHeight    =   4245
   ClientLeft      =   2610
   ClientTop       =   1680
   ClientWidth     =   3270
   FillColor       =   &H80000005&
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4935
   Icon            =   "Priority.frx":0000
   Left            =   2550
   LinkTopic       =   "PriorityForm"
   ScaleHeight     =   4245
   ScaleWidth      =   3270
   Top             =   1050
   Width           =   3390
   Begin VB.TextBox QueueText 
      Height          =   4215
      Left            =   1320
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      Text            =   "Priority.frx":000C
      Top             =   0
      Width           =   1935
   End
   Begin VB.CommandButton CmdEnter 
      Caption         =   "Enter"
      Default         =   -1  'True
      Height          =   495
      Left            =   0
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   360
      Width           =   1215
   End
   Begin VB.CommandButton CmdLeave 
      Cancel          =   -1  'True
      Caption         =   "Leave"
      Height          =   495
      Left            =   0
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   960
      Width           =   1215
   End
   Begin VB.TextBox NewItem 
      Height          =   315
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1215
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "QueuesForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Priority.FRM
'
' Main form for heap-based priority queue program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Private Queue As New HeapPQueue


' ************************************************
' Add an item to the priority queue.
' ************************************************
Private Sub CmdEnter_Click()
    On Error Resume Next
    Queue.Push CLng(Trim$(NewItem.Text))
    NewItem.Text = ""
    NewItem.SetFocus
    DisplayQueue
End Sub

' ************************************************
' Remove the highest priority item from the queue.
' ************************************************
Private Sub CmdLeave_Click()
Dim value As Long

    value = Queue.Pop()
    NewItem.Text = value
    DisplayQueue
End Sub

' ************************************************
' Display the items in the queue.
' ************************************************
Private Sub DisplayQueue()
    QueueText.Text = Queue.TextValue
End Sub

Private Sub Form_Load()
    DisplayQueue
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub

Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program uses a heap to manage a priority queue." & vbCrLf & vbCrLf
    txt = txt & "Enter a number and click the Enter button to add an item to the queue." & vbCrLf & vbCrLf
    txt = txt & "Click the Leave button to remove the highest priority item from the queue."
    
    MsgBox txt, vbOKOnly, "Help About ... Priority"
End Sub

