VERSION 4.00
Begin VB.Form UnsortForm 
   Caption         =   "Unsort"
   ClientHeight    =   4590
   ClientLeft      =   2970
   ClientTop       =   1305
   ClientWidth     =   3270
   Height          =   5280
   Left            =   2910
   LinkTopic       =   "Form1"
   ScaleHeight     =   4590
   ScaleWidth      =   3270
   Top             =   675
   Width           =   3390
   Begin VB.CommandButton CmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   495
      Left            =   0
      TabIndex        =   1
      Top             =   360
      Width           =   1095
   End
   Begin VB.TextBox ItemsText 
      Height          =   285
      Left            =   600
      TabIndex        =   0
      Text            =   "100"
      Top             =   0
      Width           =   495
   End
   Begin VB.TextBox UnsortedText 
      BackColor       =   &H8000000F&
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4575
      Left            =   2280
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   0
      Width           =   975
   End
   Begin VB.TextBox SortedText 
      BackColor       =   &H8000000F&
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4575
      Left            =   1200
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   0
      Width           =   975
   End
   Begin VB.Label Label1 
      Caption         =   "# Items"
      Height          =   255
      Left            =   0
      TabIndex        =   4
      Top             =   0
      Width           =   615
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "UnsortForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Unsort.FRM
'
' Main form for unsorting example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit
' ************************************************
' Present help about the program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program randomizes the items in a list." & vbCrLf & vbCrLf
    txt = txt & "Specify the number of items the list should have and click the Go button. The program will create the list and display it sorted and randomly arranged."

    MsgBox txt, vbOKOnly, "Help About ... Unsort"
End Sub

' ************************************************
' Display the array values in the TextBox.
' ************************************************
Private Sub ShowList(List() As Long, ctl As TextBox, min As Long, max As Long)
Dim txt As String
Dim i As Long

    For i = min To max
        txt = txt & Format$(List(i), "@@@@@") & vbCrLf
    Next i
    ctl.Text = txt
End Sub

' ************************************************
' Unsort the items.
' ************************************************
Private Sub CmdGo_Click()
Dim List() As Long
Dim num_items As Long
Dim i As Long

    MousePointer = vbHourglass
    
    num_items = CLng(ItemsText.Text)
    ReDim List(1 To num_items)
    For i = 1 To num_items
        List(i) = i
    Next i
    
    ShowList List(), SortedText, 1, num_items
    Unsort List(), 1, num_items
    ShowList List(), UnsortedText, 1, num_items

    MousePointer = vbDefault
End Sub

Private Sub Form_Load()
    Randomize
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub


