VERSION 4.00
Begin VB.Form HashForm 
   Caption         =   "Rand"
   ClientHeight    =   4245
   ClientLeft      =   480
   ClientTop       =   1740
   ClientWidth     =   8445
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4935
   Icon            =   "Rand.frx":0000
   Left            =   420
   LinkTopic       =   "Form1"
   ScaleHeight     =   4245
   ScaleWidth      =   8445
   Top             =   1110
   Width           =   8565
   Begin VB.Frame Frame1 
      Caption         =   "Table Creation"
      Height          =   1215
      Left            =   0
      TabIndex        =   13
      Top             =   0
      Width           =   1815
      Begin VB.CommandButton CmdNewTable 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         Caption         =   "Create Table"
         Height          =   375
         Left            =   240
         TabIndex        =   1
         Top             =   720
         Width           =   1335
      End
      Begin VB.TextBox TableSize 
         Height          =   285
         Left            =   1080
         TabIndex        =   0
         Text            =   "100"
         Top             =   360
         Width           =   615
      End
      Begin VB.Label Label1 
         Caption         =   "Table Size"
         Height          =   255
         Index           =   3
         Left            =   120
         TabIndex        =   14
         Top             =   360
         Width           =   975
      End
   End
   Begin VB.Frame Frame3 
      Caption         =   "Random Items"
      Height          =   1575
      Left            =   0
      TabIndex        =   17
      Top             =   1200
      Width           =   1815
      Begin VB.TextBox NumItemsText 
         Height          =   285
         Left            =   840
         TabIndex        =   2
         Text            =   "75"
         Top             =   360
         Width           =   855
      End
      Begin VB.TextBox MaxValueText 
         Height          =   285
         Left            =   840
         TabIndex        =   3
         Text            =   "999"
         Top             =   720
         Width           =   855
      End
      Begin VB.CommandButton CmdAddRandom 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         Caption         =   "Create Items"
         Enabled         =   0   'False
         Height          =   375
         Left            =   240
         TabIndex        =   4
         Top             =   1080
         Width           =   1335
      End
      Begin VB.Label Label1 
         Caption         =   "# Items"
         Height          =   255
         Index           =   6
         Left            =   120
         TabIndex        =   10
         Top             =   360
         Width           =   735
      End
      Begin VB.Label Label1 
         Caption         =   "Max"
         Height          =   255
         Index           =   2
         Left            =   120
         TabIndex        =   11
         Top             =   720
         Width           =   615
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Search"
      Height          =   1215
      Left            =   0
      TabIndex        =   15
      Top             =   2760
      Width           =   1815
      Begin VB.TextBox NewItem 
         Height          =   285
         Left            =   840
         TabIndex        =   5
         Top             =   360
         Width           =   855
      End
      Begin VB.CommandButton CmdAdd 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         Caption         =   "Add"
         Enabled         =   0   'False
         Height          =   375
         Left            =   240
         TabIndex        =   6
         Top             =   720
         Width           =   615
      End
      Begin VB.CommandButton CmdFind 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         Caption         =   "Find"
         Enabled         =   0   'False
         Height          =   375
         Left            =   960
         TabIndex        =   7
         Top             =   720
         Width           =   615
      End
      Begin VB.Label Label1 
         Caption         =   "Value"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   16
         Top             =   360
         Width           =   615
      End
   End
   Begin VB.Label StatusLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   0
      TabIndex        =   12
      Top             =   3990
      Width           =   8415
   End
   Begin VB.Label TableLabel 
      Alignment       =   2  'Center
      Caption         =   "0"
      Height          =   255
      Index           =   0
      Left            =   1920
      TabIndex        =   9
      Top             =   90
      Width           =   615
   End
   Begin VB.Label TableControl 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Index           =   0
      Left            =   1920
      TabIndex        =   8
      Top             =   345
      Visible         =   0   'False
      Width           =   615
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "HashForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Rand.FRM
'
' Main form for hashing with pseudo-random
' probing example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Const GAP = 40

Dim MaxValue As Long

Dim HashTable As New PseudoRandomHashTable
' ************************************************
' Build controls to display the table.
' ************************************************
Private Sub BuildTableControls(num_entries As Integer)
Static MaxEntry As Integer

Dim i As Integer
Dim hgt As Single
Dim wid As Single
Dim x As Single
Dim y As Single

    wid = TableControl(0).Width
    x = TableControl(MaxEntry).Left
    hgt = TableControl(0).Height
    y = TableControl(MaxEntry).Top

    ' Load new entries
    For i = MaxEntry + 1 To num_entries - 1
        Load TableControl(i)
        If (i Mod 10) = 0 Then
            x = TableControl(0).Left
            y = y + hgt + GAP
        Else
            x = x + wid + GAP
        End If
        TableControl(i).Top = y
        TableControl(i).Left = x
    Next i
    If MaxEntry < num_entries - 1 Then MaxEntry = num_entries - 1
    
    ' Make needed entries visible
    For i = 0 To num_entries - 1
        TableControl(i).Visible = True
        TableControl(i).Caption = ""
    Next i

    ' Hide entries no longer needed
    For i = num_entries To MaxEntry
        TableControl(i).Visible = False
    Next i
End Sub

' ************************************************
' Add an item to the table.
' ************************************************
Private Sub CmdAdd_Click()
Dim Value As Long
Dim probes As Integer
Dim status As Integer
Dim pos As Integer

    MousePointer = vbHourglass
    DoEvents

    If Not IsNumeric(NewItem.Text) Then NewItem.Text = "1"
    Value = CLng(NewItem.Text)
    If Value > MaxValue Then MaxValue = Value
    
    status = HashTable.InsertItem(Value, pos, probes)
    Select Case status
        Case HASH_TABLE_FULL
            HighlightItem -1
            DisplayStatus "Table full.", probes
        Case HASH_FOUND
            HighlightItem pos
            DisplayStatus "Found.", probes
        Case HASH_INSERTED
            HighlightItem pos
            DisplayStatus "Inserted.", probes
    End Select
    MousePointer = vbDefault
End Sub

' ************************************************
' Add random items to the table.
' ************************************************
Private Sub CmdAddRandom_Click()
Dim num As Integer
Dim done As Integer
Dim probes As Integer
Dim status As Integer
Dim Value As Long
Dim max_value As Long
Dim pos As Integer

    max_value = CLng(MaxValueText.Text)
    num = CInt(NumItemsText.Text)
    If num >= max_value Then
        Beep
        MsgBox "Max is too small."
        Exit Sub
    End If
    
    MousePointer = vbHourglass
    DoEvents

    done = 0
    Do While done < num
        Value = Int(max_value * Rnd) + 1
        If Value > MaxValue Then MaxValue = Value
        status = HashTable.InsertItem(Value, pos, probes)
        Randomize   ' Rerandomize.
        Select Case status
            Case HASH_TABLE_FULL
                Exit Do
            Case HASH_INSERTED
                done = done + 1
        End Select
    Loop
    DisplayStatus "Done.", probes
    HighlightItem -1
    MousePointer = vbDefault
End Sub

' ************************************************
' Find an item.
' ************************************************
Private Sub CmdFind_Click()
Dim Value As Long
Dim probes As Integer
Dim status As Integer
Dim pos As Integer

    MousePointer = vbHourglass
    DoEvents

    If Not IsNumeric(NewItem.Text) Then NewItem.Text = "1"
    
    Value = CLng(NewItem.Text)
    status = HashTable.LocateItem(Value, pos, probes)
    Select Case status
        Case HASH_NOT_FOUND
            HighlightItem -1
            DisplayStatus "Not found.", probes
        Case HASH_FOUND
            HighlightItem pos
            DisplayStatus "Found.", probes
    End Select
    MousePointer = vbDefault
End Sub

' ************************************************
' Create a new hash table.
' ************************************************
Private Sub CmdNewTable_Click()
Dim size As Integer

    MousePointer = vbHourglass
    DoEvents

    If Not IsNumeric(TableSize.Text) Then TableSize.Text = "10"
    
    HighlightItem -1
    size = CInt(TableSize.Text)
    BuildTableControls size
    HashTable.CreateTable size
    
    TableSize.Text = ""
    MaxValue = 1
    StatusLabel.Caption = "Table created."
    CmdAddRandom.Enabled = True
    MousePointer = vbDefault
End Sub

' ************************************************
' Compute the average number of probes necessary
' for all possible inputs.
' ************************************************
Private Sub ComputeAverageProbe(ave_succ As Single, ave_unsucc As Single)
Dim status As Integer
Dim trial As Long
Dim succ As Long
Dim unsucc As Long
Dim succ_probes As Long
Dim unsucc_probes As Long
Dim pos As Integer
Dim probes As Integer

    For trial = 1 To MaxValue
        status = HashTable.LocateItem(trial, pos, probes)
        If status = HASH_FOUND Then
            succ = succ + 1
            succ_probes = succ_probes + probes
        Else
            unsucc = unsucc + 1
            unsucc_probes = unsucc_probes + probes
        End If
    Next trial
    If succ > 0 Then
        ave_succ = CDbl(succ_probes) / CDbl(succ)
    Else
        ave_succ = 0
    End If
    If unsucc > 0 Then
        ave_unsucc = CDbl(unsucc_probes) / CDbl(unsucc)
    Else
        ave_unsucc = 0
    End If
End Sub

' ************************************************
' Display status information.
' ************************************************
Private Sub DisplayStatus(msg As String, probes As Integer)
Dim ave_succ As Single
Dim ave_unsucc As Single

    ComputeAverageProbe ave_succ, ave_unsucc
    StatusLabel.Caption = msg & "   This probe:" & Str$(probes) & ".   Ave successful probe: " & Format$(ave_succ, "0.00") & ".  Ave unsuccessful probe: " & Format$(ave_unsucc, "0.00") & "."
End Sub

Private Sub Form_Load()
Dim i As Integer

    Randomize
    For i = 1 To 9
        Load TableLabel(i)
        TableLabel(i).Caption = Format$(i)
        TableLabel(i).Left = TableLabel(i - 1).Left + TableLabel(i).Width + GAP
        TableLabel(i).Visible = True
    Next i
End Sub

' ************************************************
' Highlight the item we just found.
' ************************************************
Public Sub HighlightItem(pos As Integer)
Static HighlightedItem As Integer

    If HighlightedItem >= 0 Then
        TableControl(HighlightedItem).BackColor = BackColor
        TableControl(HighlightedItem).ForeColor = ForeColor
    End If

    HighlightedItem = pos
    If HighlightedItem >= 0 Then
        TableControl(HighlightedItem).BackColor = ForeColor
        TableControl(HighlightedItem).ForeColor = BackColor
    End If
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub

' ************************************************
' Present help for the program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String

    txt = "This program demonstrates open addressing with pseudo-random probing. The main areas on the form are:" & vbCrLf & vbCrLf
    txt = txt & "    Table Creation: Enter the size of the hash table to create. Then click the Create Table button to create a new hash table." & vbCrLf & vbCrLf
    txt = txt & "    Random Items: Enter the number and maximum value of the items you want created and click the Create Items button. The program will insert random items into the table." & vbCrLf & vbCrLf
    txt = txt & "    Search: Enter a value and click the Add or Find button to make the program add the item or find it in the table."
    
    MsgBox txt, vbOKOnly, "Help About ... Rand"
End Sub

Private Sub NewItem_Change()
    CmdAdd.Enabled = (Trim$(NewItem.Text <> ""))
    CmdFind.Enabled = CmdAdd.Enabled
End Sub

Private Sub TableControl_Click(Index As Integer)
    If HashTable.PositionUsed(Index) Then
        HighlightItem (Index)
        NewItem.Text = TableControl(Index).Caption
    End If
End Sub

Private Sub TableSize_Change()
    CmdNewTable.Enabled = IsNumeric(TableSize.Text)
End Sub

