VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "PathCNode"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' PathCNde.CLS
'
' Node class for label correcting shortest path
' example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Public Id As Integer
Public X As Single
Public Y As Single
Public Links As Collection
Public Dist As Integer       ' Distance from root of path tree.
Public NodeStatus As Integer ' Path tree status.
Public InLink As PathCLink   ' The link into the node.
' ************************************************
' Create a new Links collection. We do this here
' instead of simply declaring Links as:
'       Dim Links As New Collection
' so we can quickly empty the collection with:
'       Set Links = Nothing
' ************************************************
Private Sub Class_Initialize()
    Set Links = New Collection
End Sub


