VERSION 4.00
Begin VB.Form Command1Form 
   Caption         =   "Command1"
   ClientHeight    =   4230
   ClientLeft      =   1365
   ClientTop       =   1320
   ClientWidth     =   2565
   Height          =   4920
   Left            =   1305
   LinkTopic       =   "Form1"
   ScaleHeight     =   4230
   ScaleWidth      =   2565
   Top             =   690
   Width           =   2685
   Begin VB.CommandButton CmdBtn 
      Caption         =   "Command1"
      Height          =   495
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1815
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "Command1Form"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Command.FRM
'
' Main form for command object example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

' A collection of command objects.
Private CmdObjects As New Collection
' ************************************************
' Present help about the program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String

    txt = "This program demonstrates command objects. It creates an array of unrelated command objects corresponding to the controls in the button control array. When you click a button, the program invokes the corresponding object's Execute method."

    MsgBox txt, vbOKOnly, "Help About ... Command1"
End Sub
' ************************************************
' Prepare a command button.
' ************************************************
Private Sub PrepareCommand(cap As String, obj As Object)
Static Index As Integer

    If Index > 0 Then
        ' Load the button.
        Load CmdBtn(Index)
        CmdBtn(Index).Top = _
            CmdBtn(Index - 1).Top + _
            CmdBtn(Index - 1).Height + 60
    End If
    ' Set the caption and make visible.
    CmdBtn(Index).Caption = cap
    CmdBtn(Index).Visible = True
    
    ' Save the command object. Note that the command
    ' for button i is CmdObjects(i + 1).
    CmdObjects.Add obj

    Index = Index + 1
End Sub

' ************************************************
' Invoke the appropriate command.
' ************************************************
Private Sub CmdBtn_Click(Index As Integer)
    CmdObjects(Index + 1).Execute Me
End Sub

' ************************************************
' Load the command captions and objects.
' ************************************************
Private Sub Form_Load()
Dim obj As Object

    Set obj = New BeepClass
    PrepareCommand "Beep", obj

    Set obj = New BackColorClass
    obj.Color = vbBlue
    PrepareCommand "Blue", obj

    Set obj = New BackColorClass
    obj.Color = &H8000000F
    PrepareCommand "Gray", obj
    
    Set obj = New SizeFormClass
    PrepareCommand "Big", obj
    obj.Width = 4 * CmdBtn(0).Width
    obj.Height = 12 * CmdBtn(0).Height
    
    Set obj = New SizeFormClass
    PrepareCommand "Small", obj
    obj.Width = CmdBtn(0).Width + 2 * CmdBtn(0).Left + _
        Width - ScaleWidth
    obj.Height = CmdBtn(CmdBtn().UBound).Top + _
        CmdBtn(0).Top + CmdBtn(0).Height + _
        Height - ScaleHeight
End Sub

' ************************************************
' Quit.
' ************************************************
Private Sub mnuFileExit_Click()
    Unload Me
End Sub


