VERSION 4.00
Begin VB.Form FriendStacksForm 
   Appearance      =   0  'Flat
   Caption         =   "FStacks"
   ClientHeight    =   3990
   ClientLeft      =   2025
   ClientTop       =   1515
   ClientWidth     =   4950
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4680
   Icon            =   "FStacks.frx":0000
   Left            =   1965
   ScaleHeight     =   3990
   ScaleWidth      =   4950
   Top             =   885
   Width           =   5070
   Begin VB.TextBox NewItem 
      Height          =   315
      Left            =   840
      TabIndex        =   9
      Top             =   0
      Width           =   1335
   End
   Begin VB.TextBox StackText 
      Height          =   3015
      Index           =   0
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   8
      TabStop         =   0   'False
      Top             =   960
      Width           =   1575
   End
   Begin VB.TextBox StackText 
      Height          =   3015
      Index           =   1
      Left            =   1680
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   7
      TabStop         =   0   'False
      Top             =   960
      Width           =   1575
   End
   Begin VB.TextBox StackText 
      Height          =   3015
      Index           =   2
      Left            =   3360
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   6
      TabStop         =   0   'False
      Top             =   960
      Width           =   1575
   End
   Begin VB.CommandButton CmdPop 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Pop"
      Enabled         =   0   'False
      Height          =   375
      Index           =   1
      Left            =   2520
      TabIndex        =   5
      TabStop         =   0   'False
      Top             =   480
      Width           =   735
   End
   Begin VB.CommandButton CmdPush 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Push"
      Enabled         =   0   'False
      Height          =   375
      Index           =   1
      Left            =   1680
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   480
      Width           =   735
   End
   Begin VB.CommandButton CmdPop 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Pop"
      Enabled         =   0   'False
      Height          =   375
      Index           =   2
      Left            =   4200
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   480
      Width           =   735
   End
   Begin VB.CommandButton CmdPush 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Push"
      Enabled         =   0   'False
      Height          =   375
      Index           =   2
      Left            =   3360
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   480
      Width           =   735
   End
   Begin VB.CommandButton CmdPop 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Pop"
      Enabled         =   0   'False
      Height          =   375
      Index           =   0
      Left            =   840
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   480
      Width           =   735
   End
   Begin VB.CommandButton CmdPush 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Push"
      Enabled         =   0   'False
      Height          =   375
      Index           =   0
      Left            =   0
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   480
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "New item"
      Height          =   255
      Left            =   0
      TabIndex        =   10
      Top             =   0
      Width           =   855
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "FriendStacksForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' FStacks.FRM
'
' Main form for multiple friend stacks example
' program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Private Stacks(0 To 2) As New Stack

' ************************************************
' Display a stack.
' ************************************************
Private Sub DisplayStack(Index As Integer)
    StackText(Index).Text = _
        Stacks(Index).TextRepresentation
End Sub

' ************************************************
' Pop a value off of the indicated stack.
' ************************************************
Private Sub CmdPop_Click(Index As Integer)
    NewItem.Text = Stacks(Index).Pop
    CmdPop(Index).Enabled = _
        Not (Stacks(Index).IsEmpty)
    DisplayStack Index
End Sub

' ************************************************
' Push the new item onto the appropriate stack.
' ************************************************
Private Sub CmdPush_Click(Index As Integer)
    Stacks(Index).Push NewItem.Text
    NewItem.Text = ""
    CmdPop(Index).Enabled = True
    DisplayStack Index
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub

' ************************************************
' Present help about this program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String

    txt = txt & "This program demonstrates multiple stacks using friend linked lists classes." & vbCrLf & vbCrLf
    txt = txt & "Enter a value and click one of the Push buttons to add the item to a stack." & vbCrLf & vbCrLf
    txt = txt & "Click one of the Pop buttons to remove the top item from a stack."

    MsgBox txt, vbOKOnly, "Help About ... FStacks"
End Sub

' ************************************************
' Enable the Push buttons if it's not blank.
' ************************************************
Private Sub NewItem_Change()
Dim i As Integer
Dim non_blank As Boolean

    non_blank = (Trim$(NewItem.Text) <> "")
    For i = 0 To 2
        CmdPush(i).Enabled = non_blank
    Next i
End Sub

