VERSION 4.00
Begin VB.Form WinListForm 
   Caption         =   "WinList"
   ClientHeight    =   4170
   ClientLeft      =   1140
   ClientTop       =   1800
   ClientWidth     =   6765
   Height          =   4860
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   4170
   ScaleWidth      =   6765
   Top             =   1170
   Width           =   6885
   Begin VB.TextBox WindowListText 
      BackColor       =   &H8000000F&
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4095
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   0
      Width           =   6735
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuList 
      Caption         =   "&List"
      Begin VB.Menu mnuListRefresh 
         Caption         =   "&Refresh"
         Shortcut        =   ^R
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "WinListForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' WinList.FRM
'
' Main form for windows list singleton example
' program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

' ************************************************
' Display the list for the first time.
' ************************************************
Private Sub Form_Load()
    mnuListRefresh_Click
End Sub

Private Sub Form_Resize()
    WindowListText.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

' ************************************************
' Display help for this program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program uses a singleton WindowListerClass object to display a list of windows."

    MsgBox txt, vbOKOnly, "Help About ... WinList"
End Sub
Private Sub mnuFileExit_Click()
    Unload Me
End Sub

' ************************************************
' Display the list of windows.
' ************************************************
Private Sub mnuListRefresh_Click()
    WindowListText.Text = WindowLister.WindowList
End Sub

