VERSION 4.00
Begin VB.Form LinkedQueueForm 
   Appearance      =   0  'Flat
   Caption         =   "LinkedQ2"
   ClientHeight    =   4005
   ClientLeft      =   3585
   ClientTop       =   1590
   ClientWidth     =   2685
   FillColor       =   &H80000005&
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4695
   Icon            =   "LinkedQ2.frx":0000
   Left            =   3525
   LinkTopic       =   "GarbageForm"
   ScaleHeight     =   4005
   ScaleWidth      =   2685
   Top             =   960
   Width           =   2805
   Begin VB.TextBox LinkedQueueText 
      Height          =   3975
      Left            =   1320
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   0
      Width           =   1335
   End
   Begin VB.CommandButton CmdEnter 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Enter"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   495
      Left            =   0
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   360
      Width           =   1215
   End
   Begin VB.CommandButton CmdLeave 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Cancel          =   -1  'True
      Caption         =   "Leave"
      Enabled         =   0   'False
      Height          =   495
      Left            =   0
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   960
      Width           =   1215
   End
   Begin VB.TextBox NewItem 
      Height          =   315
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1215
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "LinkedQueueForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' LinkedQ2.FRM
'
' Main form for linked list based queue.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Dim Queue As New LinkedListQueue

' ************************************************
' Add a new item to the queue.
' ************************************************
Private Sub CmdEnter_Click()
    Queue.EnterQueue NewItem.Text
    NewItem.Text = ""
    SetButtons
    LinkedQueueText.Text = Queue.TextRepresentation
    NewItem.SetFocus
End Sub

' ************************************************
' Remove the top item from the queue.
' ************************************************
Private Sub CmdLeave_Click()
    NewItem.Text = Queue.LeaveQueue
    SetButtons
    LinkedQueueText.Text = Queue.TextRepresentation
End Sub


Private Sub mnuFileExit_Click()
    End
End Sub

' ************************************************
' Display help about this program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String

    txt = txt & "This program manages a queue using a doubly linked list class." & vbCrLf & vbCrLf
    txt = txt & "Enter a string and click the Enter button to add a new item to the queue." & vbCrLf & vbCrLf
    txt = txt & "Click the Leave button to remove the top item from the queue."

    MsgBox txt, vbOKOnly, "Help About ... LinkedQ2"
End Sub

' ************************************************
' The user has modified the new item text. Enable the
' correct buttons.
' ************************************************
Private Sub NewItem_Change()
    SetButtons
End Sub

' ************************************************
' Enable the cirrect buttons.
' ************************************************
Private Sub SetButtons()
    CmdEnter.Enabled = (Trim$(NewItem.Text) <> "")
    CmdLeave.Enabled = Not Queue.QueueIsEmpty
End Sub

