VERSION 4.00
Begin VB.MDIForm PolyMDI 
   Appearance      =   0  'Flat
   BackColor       =   &H8000000C&
   Caption         =   "Poly"
   ClientHeight    =   4020
   ClientLeft      =   1305
   ClientTop       =   1305
   ClientWidth     =   6765
   Height          =   4710
   Icon            =   "PolyMDI.frx":0000
   Left            =   1245
   LinkTopic       =   "PolyMDI"
   Top             =   675
   Width           =   6885
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileNewPicture 
         Caption         =   "&New Picture"
      End
      Begin VB.Menu mnuFileSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "PolyMDI"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' PolyMDI.FRM
'
' MDI form for linked list of linked list
' example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Private Sub mnuFileExit_Click()
    End
End Sub

' *******************************************************
' Create a new drawing form.
' *******************************************************
Private Sub mnuFileNewPicture_Click()
Dim frm As New DrawForm

    frm.Show
End Sub

' *******************************************************
' Present help for this program.
' *******************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String

    txt = "This program uses a linked list of polygons, each of which is a linked list of points to allow you to create any number of polygons on any number of drawing forms." & vbCrLf & vbCrLf
    txt = txt & "Each drawing form has its own linked list of polygons. When a form is destroyed, its polygons and their points are destroyed automatically." & vbCrLf & vbCrLf
    txt = txt & "Click the left mouse button to start a polygon. Click it again to add a point to the polygon." & vbCrLf & vbCrLf
    txt = txt & "Click the right mouse button to finish drawing the current polygon and prepare to start another."

    MsgBox txt, vbOKOnly, "Help About ... Poly"
End Sub

