Attribute VB_Name = "LInsertionsortStuff"
' ************************************************
' FLInsert.BAS
'
' Source code for linked list insertionsort.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

' ************************************************
' Linked list insertionsort.
' ************************************************
Public Sub LinkInsertionSort(ListTop As ListCell)
Dim new_top As New ListCell
Dim old_top As ListCell
Dim cell As ListCell
Dim after_me As ListCell
Dim nxt As ListCell

    Set old_top = ListTop.NextCell
    Do While Not (old_top Is Nothing)
        Set cell = old_top
        Set old_top = old_top.NextCell
        
        ' See where cell belongs.
        Set after_me = new_top
        Do
            Set nxt = after_me.NextCell
            If nxt Is Nothing Then Exit Do
            If nxt.Value >= cell.Value Then Exit Do
            Set after_me = nxt
        Loop
        
        ' Insert after after_me.
        Set after_me.NextCell = cell
        Set cell.NextCell = nxt
    Loop
    Set ListTop.NextCell = new_top.NextCell
End Sub

