Attribute VB_Name = "InsertionsortStuff"
' ************************************************
' Insert.BAS
'
' Source code for insertionsort.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

' ************************************************
' Insertionsort.
' ************************************************
Public Sub Insertionsort(List() As Long, min As Long, max As Long)
Dim i As Long
Dim j As Long
Dim k As Long
Dim max_sorted As Long
Dim next_num As Long

    max_sorted = min - 1
    For i = min To max
        ' This is the number we are inserting.
        next_num = List(i)
        
        ' See where it belongs in the list.
        For j = min To max_sorted
            If List(j) >= next_num Then Exit For
        Next j
        
        ' Bump the bigger sorted numbers down to make
        ' room for the new number.
        For k = max_sorted To j Step -1
            List(k + 1) = List(k)
        Next k

        ' Insert the new number.
        List(j) = next_num
        
        ' Increment the count of the sorted items.
        max_sorted = max_sorted + 1
    Next i
End Sub

